#include <stdio.h>
#include <stdlib.h>
#include "global.h"
#include "../../tcgmsg/ipcv4.0/sndrcv.h"
#include "../../tcgmsg/ipcv4.0/msgtypesc.h"
#include "macommon.h"
#include "dra.h"

#define BUFSIZE 8000000
int main(argc, argv)
int argc;
char **argv;
{
Integer heap=400000, stack=400000;
Integer me, nproc;
char buf[BUFSIZE];
Integer max_arrays=2;
double  max_sz=1e8, max_disk=2e8, max_mem=1e6;
Integer d_a, mode=DRA_R;
Integer g_a,dim1,dim2,rows,cols,block=-1;
char    name[1024], fname[1024];
Integer transp=0, reqid, one=1;
Integer index, ld;
Integer i,j,ilo,ihi,jlo,jhi,type;

    if(argc<5){
      printf("Usage: dra2mif <dra_filename> <ilo> <ihi> <jlo> <jhi>\n");
      printf("       dra_filename is the meta-file name for disk resident array\n");
      printf("       [ilo:ihi, jlo:jhi]  array section to read\n\n");
      return(1);
    }

    PBEGIN_(argc, argv);
    me=NODEID_();
    nproc=NNODES_();

    heap /= nproc;
    stack /= nproc;
    if(! MA_init((Integer)MT_F_DBL, stack, heap))
       ERROR_("MA_init failed",stack+heap);     /* initialize memory allocator*/
    GA_initialize();                            /* initialize GA */

    if(nproc != 1)GA_error("Error: does not run in parallel",nproc);

    if(DRA_init(&max_arrays, &max_sz, &max_disk, &max_mem))
       GA_error("initialization failed",0);

    if(DRA_open(argv[1],&mode, &d_a)) GA_error("dra_open failed",0);

    ilo = atoi(argv[2]); ihi = atoi(argv[3]);
    jlo = atoi(argv[4]); jhi = atoi(argv[5]);
    rows = ihi - ilo +1; 
    cols = jhi - jlo +1; 

    printf("%d %d\n",rows,cols);

    if(DRA_inquire(&d_a, &type, &dim1, &dim2, name, fname))
        GA_error("dra_inquire failed",0);

    if(type == MT_F_DCPL) GA_error("double complex not supported by MCF",0);

    if(!GA_create(&type, &rows, &cols, "temp", &block, &block, &g_a))
        GA_error("ga_create failed:",0);

    if(DRA_read_section(&transp, &g_a, &one, &rows, &one, &cols,
                                 &d_a, &ilo, &ihi, &jlo, &jhi, &reqid))
        GA_error("dra_read_section failed",0);

    if(DRA_wait(&reqid)) GA_error("dra_wait failed",0);

    GA_access(&g_a, &one, &rows, &one, &cols, &index, &ld);

    if(ld != rows) GA_error("ld != rows",ld); 

    for(i=0; i<rows; i++){
       for(j=0; j<cols; j++){
          if(type == MT_F_DBL)printf("%12e ",DBL_MB[index-1+i + j*ld]);
          else printf("%d ",INT_MB[index-1+i+j*ld]);
       }
       printf("\n");
    }
    
    GA_destroy(&g_a);

    GA_terminate();
    PEND_();
    return 0;
}
