/* file global.h */

#ifndef GLOBAL_H
#define GLOBAL_H

#include "typesf2c.h"


#ifdef FALSE
#undef FALSE
#endif
#ifdef TRUE 
#undef TRUE
#endif
#ifdef CRAY_YMP
#include <fortran.h>
#define FALSE _btol(0)
#define TRUE  _btol(1)
#else
#define FALSE (logical) 0
#define TRUE  (logical) 1
#endif

#include "c.names.h"
#if defined(CRAY) || defined(WIN32)
#  include "cray.names.h"
#endif


#if defined(__STDC__) || defined(__cplusplus) || defined(WIN32)
# define ARGS_(s) s
#else
# define ARGS_(s) ()
#endif

extern Integer  FATR ga_nnodes_   ARGS_(( void));
extern Integer FATR ga_nodeid_   ARGS_(( void));
extern Integer FATR ga_inquire_memory_  ARGS_(( void));
extern Integer FATR ga_memory_avail_ ARGS_(( void));
extern Integer FATR ga_read_inc_ ARGS_((Integer*, Integer*, Integer*, Integer* ));
extern Integer FATR ga_verify_handle_ ARGS_((Integer* ));

#if defined(CRAY) || defined(WIN32)
extern void ga_check_handle_ ARGS_((Integer* g_a, _fcd fstring)) ;
#else
extern void ga_check_handle_ ARGS_((Integer* g_a, char* fstring, int slen)) ;
#endif

#if defined(CRAY) || defined(WIN32)
extern logical ga_create_ ARGS_((Integer* type, Integer* dim1, Integer* dim2, _fcd array_name, Integer* chunk1, Integer* chunk2, Integer* g_a)) ;
#else
extern logical ga_create_ ARGS_((Integer* type, Integer* dim1, Integer* dim2, char* array_name, Integer* chunk1, Integer* chunk2, Integer* g_a, int slen)) ;
#endif

extern logical ga_create ARGS_((Integer*, Integer*, Integer*, char*, Integer*,                                  Integer*, Integer*));
extern logical nga_create ARGS_((Integer, Integer, Integer*, char*,
                                 Integer* , Integer*)) ;

#if defined(CRAY) || defined(WIN32)
extern logical nga_create_ ARGS_((Integer *type, Integer *ndim, Integer *dims, _fcd array_name, Integer *chunk, Integer *g_a)) ;
#else
extern logical nga_create_ ARGS_((Integer *type, Integer *ndim, Integer *dims, char* array_name, Integer *chunk, Integer *g_a, int slen)) ;
#endif

#if defined(CRAY) || defined(WIN32)
extern logical ga_create_irreg_ ARGS_((Integer* type, Integer* dim1, Integer* dim2, _fcd array_name, Integer* map1, Integer* nblock1, Integer* map2, Integer* nblock2, Integer* g_a)) ;
#else
extern logical ga_create_irreg_ ARGS_((Integer* type, Integer* dim1, Integer* dim2, char* array_name, Integer* map1, Integer* nblock1, Integer* map2, Integer* nblock2, Integer* g_a, int slen)) ;
#endif

extern logical ga_create_irreg ARGS_((Integer*, Integer*, Integer*, char*,                                            Integer*, Integer*, Integer*, Integer*,                                         Integer* ));
extern logical nga_create_irreg ARGS_((Integer, Integer, Integer*, char*,
                                       Integer*, Integer*, Integer*)) ;

extern logical ga_create_mutexes_ ARGS_((Integer*));

#if defined(CRAY) || defined(WIN32)
extern logical ga_duplicate_ ARGS_((Integer* g_a, Integer* g_b, _fcd array_name)) ;
#else
extern logical ga_duplicate_ ARGS_((Integer* g_a, Integer* g_b, char* array_name, int slen)) ;
#endif

extern logical ga_create ARGS_((Integer*, Integer*, Integer*, char*, Integer*,                                  Integer*, Integer*));
extern logical ga_create_irreg ARGS_((Integer*, Integer*, Integer*, char*,                                            Integer*, Integer*, Integer*, Integer*,                                         Integer* ));
extern logical FATR ga_create_mutexes_ ARGS_((Integer*));
extern logical FATR ga_destroy_  ARGS_((Integer* ));
extern logical FATR ga_destroy_mutexes_  ARGS_((void ));
extern logical ga_duplicate ARGS_((Integer*, Integer*, char* ));
extern logical FATR ga_compare_distr_ ARGS_((Integer*, Integer* ));
extern logical FATR ga_locate_   ARGS_((Integer*, Integer*, Integer*, Integer* ));
extern void FATR ga_lock_        ARGS_((Integer* ));
extern void FATR ga_unlock_      ARGS_((Integer* ));
extern void ga_check_handle ARGS_((Integer*, char*));
extern logical FATR ga_locate_region_ ARGS_((Integer*, Integer*, Integer*, Integer*,                                         Integer*, Integer map[][5], Integer* ));
extern void  FATR ga_acc_   ARGS_((Integer*, Integer*, Integer*, Integer*, Integer*,                               void*, Integer*, void* ));
extern void FATR nga_acc_   ARGS_((Integer*, Integer*, Integer*,
                                   void*, Integer*, void*)) ;
extern void FATR ga_access_ ARGS_((Integer*, Integer*, Integer*, Integer*, Integer*,                               Integer*, Integer* ));
extern void nga_access_ptr ARGS_((Integer*, Integer*, Integer*, void*,
                                  Integer*)) ;
extern void FATR nga_access_ ARGS_((Integer*, Integer*, Integer*,
                                    Integer*, Integer*)) ;

extern void FATR ga_brdcst_ ARGS_((Integer*, Void*, Integer*, Integer* ));
extern void FATR ga_gather_ ARGS_((Integer*, Void*, Integer*, Integer*, Integer* ));
extern void ga_dgop ARGS_((Integer, DoublePrecision*, Integer, char* ));
extern void FATR ga_distribution_ ARGS_((Integer*, Integer*, Integer*, Integer*,                                         Integer*, Integer* ));
extern void FATR nga_distribution_ ARGS_((Integer*, Integer*, Integer*,
                                         Integer*)) ;
extern void FATR ga_scatter_ ARGS_((Integer*, Void*, Integer*, Integer*, Integer*));
extern void FATR  ga_scatter_acc_ ARGS_((Integer*, Void*, Integer*, Integer*,
                                         Integer*, Void*)) ;

extern void ga_error    ARGS_((char*, Integer));
extern void FATR ga_init_fence_   ARGS_(( void));
extern void FATR ga_fence_   ARGS_(( void));
extern void FATR ga_get_     ARGS_((Integer*, Integer*, Integer*, Integer*, Integer*,                               Void*, Integer* ));
extern void FATR nga_get_    ARGS_((Integer*, Integer*, Integer*,
                                    Void*, Integer*)) ;

extern void ga_igop     ARGS_((Integer, Integer*, Integer, char* ));
extern void FATR ga_initialize_ ARGS_(( void));
extern void FATR ga_initialize_ltd_ ARGS_(( Integer* ));
extern void FATR ga_inquire_ ARGS_((Integer*, Integer*, Integer*, Integer* ));
extern void FATR nga_inquire_ ARGS_((Integer*, Integer*, Integer*, Integer*)) ;
extern void ga_inquire_name ARGS_((Integer*, char** ));
extern void FATR ga_list_data_servers_ ARGS_((Integer* ));
extern void FATR ga_list_nodeid_ ARGS_((Integer*, Integer* ));
extern void FATR ga_num_data_servers_ ARGS_((Integer* ));
extern void FATR ga_put_  ARGS_((Integer*, Integer*, Integer*, Integer*, Integer*,                               Void*, Integer* ));
extern void FATR nga_put_ ARGS_((Integer*, Integer*, Integer*,
                                 Void*, Integer*)) ;

extern void FATR ga_release_ ARGS_((Integer*, Integer*, Integer*,
                                    Integer*, Integer*)) ;
extern void FATR nga_release_ ARGS_((Integer*, Integer* lo, Integer* hi)) ;

extern void FATR ga_release_update_ ARGS_((Integer*, Integer*, Integer*, Integer*,                                         Integer* ));
extern void FATR nga_release_update_ ARGS_((Integer*, Integer*, Integer*)) ;

extern void FATR ga_sync_ ARGS_(( void));
extern void FATR ga_terminate_ ARGS_(( void));
extern logical FATR ga_uses_ma_ ARGS_(( void));
extern logical FATR ga_memory_limited_ ARGS_(( void));


extern void ga_copy_patch ARGS_((char *, Integer *, Integer *, Integer *,                                        Integer *, Integer *, Integer *, Integer *,                                     Integer *, Integer *, Integer *));
extern DoublePrecision ga_ddot_patch ARGS_((Integer *, char*, Integer *,                                                   Integer *, Integer *, Integer *,                                                Integer *, char*, Integer *,
                                           Integer *, Integer *, Integer *));
extern DoubleComplex ga_zdot_patch ARGS_((Integer *, char*, Integer *,                                                   Integer *, Integer *, Integer *,                                                Integer *, char*, Integer *,
                                           Integer *, Integer *, Integer *));
extern void FATR ga_fill_  ARGS_((Integer *g_a, void* val)) ;

extern void FATR ga_fill_patch_  ARGS_((Integer *, Integer *, Integer *, Integer *,                                     Integer *, Void *));
extern void FATR ga_scale_patch_  ARGS_((Integer *, Integer *, Integer *, Integer *,                                     Integer *, DoublePrecision *));
extern void FATR ga_add_patch_   ARGS_((DoublePrecision *, Integer *,                                                   Integer *, Integer *, Integer *, Integer *,                                     DoublePrecision *, Integer *,                                                   Integer *, Integer *, Integer *, Integer *,                                     Integer *, Integer *, Integer *, Integer *,                                     Integer *  ));
extern void ga_matmul_patch  ARGS_((char *, char *,                                                                 DoublePrecision *, DoublePrecision *,                                           Integer *, Integer *, Integer *, Integer *,                                     Integer *, Integer *, Integer *,                                                Integer *, Integer *, Integer *, Integer *, 
                                    Integer *, Integer *, Integer *, Integer*));

extern void FATR ga_copy_   ARGS_((Integer *, Integer *));
extern void FATR ga_print_  ARGS_((Integer *));
extern void FATR ga_print_stats_();
extern void FATR ga_zero_   ARGS_((Integer *));
extern void FATR ga_scale_  ARGS_((Integer *, void *));
extern void FATR ga_add_   ARGS_((Void *, Integer *, Void *,                                Integer *, Integer *));
extern Integer FATR ga_idot_ ARGS_((Integer *, Integer *));
extern DoublePrecision FATR ga_ddot_ ARGS_((Integer *, Integer *));
extern DoubleComplex FATR ga_zdot_ ARGS_((Integer *, Integer *));
extern void FATR ga_print_patch_ ARGS_((Integer *, Integer *, Integer *, Integer *,                                     Integer *, Integer *));

extern void ga_summarize     ARGS_((logical*));
extern void FATR ga_symmetrize_   ARGS_((Integer *)); 
extern void FATR ga_transpose_    ARGS_((Integer *, Integer *));
extern void FATR ga_diag_seq_     ARGS_((Integer *, Integer *, Integer *,                                                DoublePrecision *));
extern void FATR ga_diag_reuse_   ARGS_((Integer*, Integer *, Integer *, Integer *,
                                  DoublePrecision *));
extern void FATR ga_diag_std_     ARGS_((Integer *, Integer *, DoublePrecision *));
extern void FATR ga_diag_std_seq_ ARGS_((Integer *, Integer *, DoublePrecision *));
extern void ga_lu_solve      ARGS_((char *, Integer *, Integer *));
extern void ga_lu_solve_seq  ARGS_((char *, Integer *, Integer *));

extern void ga_dgemm ARGS_((char *, char *, Integer *, Integer *, Integer *,                                DoublePrecision *, Integer *, Integer *,                                        DoublePrecision *, Integer *));
extern void FATR ga_diag_ ARGS_((Integer *, Integer *, Integer *,DoublePrecision *));
extern void FATR ga_proc_topology_ ARGS_((Integer *g_a, Integer *proc,  Integer *pr,\
                                     Integer *pc));
extern void FATR nga_proc_topology_ ARGS_((Integer*, Integer*, Integer*)) ;


extern void FATR ga_sort_permut_ ARGS_((Integer* g_a, Integer* index, Integer* i, Integer* j, Integer* nv));
#undef ARGS_


extern DoubleComplex   *DCPL_MB;
extern DoublePrecision *DBL_MB;
extern Integer         *INT_MB;

#endif 
